<template lang="html">
<div class="butter-textarea">
  <butter-icon v-if="!disabled && value && value.length" class="clear" name="close" @click.native="clear" />
  <h2 v-if="heading">{{ heading }} <butter-icon v-if="copy" class="copy" name="ui-copy" @click.native="clipboardCopy" /> <span v-show="copied">Copied!</span></h2>
  <form-field v-bind="$props" :value="internal" ref="form-field" class="textarea-field">
    <textarea v-if="!disabled"
      ref="input"
      :type="type"
      :placeholder="placeholder"
      v-model="internal"
      @blur="$emit('blur', $event)"
      @focus="$emit('focus', $event)"
      />
      <span v-else class="textarea">{{ internal }}</span>
  </form-field>
  </div>
</template>

<script>
export default {
  props: {
    'label': String,
    'heading': String,
    'note': String,
    'placeholder': String,
    'value': String,
    'error': String,
    'type': {
      type: String,
      default: 'text',
    },
    'disabled': {
      type: Boolean,
      default: false,
    },
    'copy': {
      type: Boolean,
      default: false,
    }
  },
  data() {
    return {
      internal: this.value,
      minHeight: 0,
      copied: false,
    };
  },
  mounted() {
    this.textareaResize();
  },
  methods: {
    clear() {
      this.internal = '';
      this.$emit('input','');
      this.$refs['form-field'].hasContent = false;
      this.$refs['form-field'].hasFocus = false;
    },
    textareaResize(retry) {
      // TODO: collapse height if scroll and min are equal

      if(this.$refs.input) {
        this.minHeight = Math.max(this.$refs.input.scrollHeight,this.minHeight);
        this.$refs.input.style.minHeight = this.minHeight+'px';
//        console.log("Height: ",this.$refs.input.scrollHeight);
      } /* else if(retry !== false) {
        setTimeout(() => this.textareaResize(false),300);
      } */
    },
    async clipboardCopy($event) {
      if (navigator.clipboard && window.isSecureContext) {
        await navigator.clipboard.writeText(this.value);
        this.copied = true;
        setTimeout(_ => this.copied=false, 1000);
      }
    },

  },
  watch: {
    value(value) {
      this.internal = value;
      this.textareaResize();
    },
    internal(value) {
      this.$emit('input',value);
      this.textareaResize();
    },

  },
}
</script>

<style lang="scss" scoped>
@import 'butter-themes';
@import 'butter-mixins';

.butter-textarea {
  position: relative;
}

.butter-textarea .clear {
  @include themify($themes) {
    fill: themed('color-text-inactive');
  }
  position: absolute;
  top: $grid;
  right: $grid;
  z-index: 9;
}

.copy {
  @include themify($themes) {
    color: themed('color-button-primary');
  }
  margin-left: $grid;
}

h2 {
  display: flex;
  align-items: center;
  margin: 0 0 $grid*1.5;

  span {
    @include font(14px, 23px, $font-sans);
    margin: 0 0 0 $grid;
  }
}

textarea {
  @include themify($themes) {
    color: themed('color-text-primary');
  }
  width: 100%;

  background-color: transparent;
  border: none;

  resize: none;
}

</style>
